#include <time.h>
#include <dos.h>
#include <conio.h>
#include <fstream.h>
#include <stdio.h>

#include "com.h"


#define FRE 115200L
#define TIMEOUT 20

clock_t start = (clock_t)0;

void Com::Init(int num, long fre, signed char param)
{
  int t;
  switch(num) {
      case 0 : nport = 0x3f8; break;
      case 1 : nport = 0x2f8; break;
      case 2 : nport = 0x3e8; break;
      case 3 : nport = 0x2e8; break;
      default : nport = num;
  }
  int np = nport;
  t = FRE/fre;
  param &= 0x7f;
  asm {
      mov dx, np
      add dx, 3
      mov al, param
      or  al, 80h
      out dx, al

      mov dx, np
      mov ax, t
      out dx, ax

      mov dx, np
      add dx, 3
      mov al, param
      out dx, al

      mov dx, np
      add dx, 1
      mov al, 0
      out dx, al

      mov dx, np
      add dx, 4
      mov al, 1
      out dx, al
  }
  if(Stat()&RxRDY) {
      asm {
          mov dx, np
          in  al, dx
      }
  }
}

unsigned Com::Stat()
 { int np = nport+5;
  asm {
      mov dx, np
      in  ax, dx
  }
  return _AX;
 }

void Com::Send(signed char pch)
 { int np = nport;
  while(!Stat()&TxRDY);
  asm {
      mov dx, np
      mov al, pch
      out dx, al
  }
 }


signed char Com::Get()
 { int np = nport;
  if(!(Stat()&RxRDY))
     {
      clock_t start = clock();
      do {
          if( clock()-start > TIMEOUT ) return -1;
         } while(!(Stat()&RxRDY));
     }
  asm {
      mov dx, np
      in  al, dx
  }
  return _AL;
 }

signed char Com::Getn()
 { int np = nport;
  if(!(Stat()&RxRDY)) return -1;
  asm {
      mov dx, np
      in  al, dx
  }
  return _AL;
 }

void Com::Control(signed char pst)
 { int np = nport+4;
  asm {
      mov dx, np
      mov al, pst
      out dx, al
  }
 }

void main(int argc, char *argv[])
{ unsigned char ch; unsigned int out=0;
  Com Port;
  ofstream fout;
  if(argc>2) {
     switch(*argv[2]) {
        case '1' : Port.Init(0,1200,0x7); break;
        case '2' : Port.Init(1,1200,0x7); break;
        case '3' : Port.Init(2,1200,0x7); break;
        case '4' : Port.Init(3,1200,0x7); break;
        default : Port.Init(0,1200,0x7); break;
     }
  }
  else Port.Init(0,1200,0x7);
  if(argc>1) {
     fout.open(argv[1], ios::binary);
     if(!fout) {cputs("Error open file \n\r");};
     out = 1;
  }
  cout << "Ready...\n";
  getch();
  do {
  Port.Send(6);
  while(!kbhit()) {
    ch = Port.Get();
    if(ch == 0xff) {cout << "Timeout\n"; continue;}
    if(ch == 3) {Port.Send(6); continue;}
    cout << ch; if(out) fout << ch;
  }
  }
  while(getch()!=27);
  if(out) fout.close();
}